VERSION 2.00
Begin Form Eigencalc 
   Caption         =   "Eigenvalue Calculator"
   ClientHeight    =   5820
   ClientLeft      =   240
   ClientTop       =   450
   ClientWidth     =   9105
   Height          =   6510
   Icon            =   EIGEN.FRX:0000
   Left            =   180
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   9105
   Top             =   -180
   Width           =   9225
   Begin Frame Frame1 
      Height          =   975
      Left            =   120
      TabIndex        =   2
      Top             =   4800
      Width           =   8895
      Begin CommandButton Initialize 
         Caption         =   "Initialize"
         Height          =   375
         Left            =   7440
         TabIndex        =   8
         Top             =   360
         Width           =   1335
      End
      Begin CommandButton restore_original 
         Caption         =   "Restore Previous"
         Height          =   375
         Left            =   5640
         TabIndex        =   7
         Top             =   360
         Width           =   1575
      End
      Begin CommandButton clearall 
         Caption         =   "Clear All"
         Height          =   375
         Left            =   4440
         TabIndex        =   6
         Top             =   360
         Width           =   975
      End
      Begin CommandButton eigenvectors 
         Caption         =   "Show Eigenvectors"
         Enabled         =   0   'False
         Height          =   375
         Left            =   2280
         TabIndex        =   5
         Top             =   360
         Width           =   1935
      End
      Begin CommandButton Start_compute 
         Caption         =   "Calculate"
         Height          =   375
         Left            =   1080
         TabIndex        =   4
         Top             =   360
         Width           =   975
      End
      Begin TextBox Text5 
         Height          =   375
         Left            =   360
         TabIndex        =   3
         Top             =   360
         Width           =   495
      End
      Begin Label Label5 
         AutoSize        =   -1  'True
         Caption         =   "Dimension"
         Height          =   195
         Left            =   120
         TabIndex        =   9
         Top             =   120
         Width           =   885
      End
   End
   Begin Grid Grid2 
      Cols            =   6
      FixedCols       =   1
      FixedRows       =   1
      Height          =   975
      Left            =   120
      Rows            =   2
      ScrollBars      =   3  'Both
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   3720
      Width           =   8895
   End
   Begin Grid Grid1 
      Cols            =   6
      FixedCols       =   1
      FixedRows       =   1
      Height          =   3135
      Left            =   120
      Rows            =   6
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   480
      Width           =   8895
   End
   Begin TextBox Text1 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   1695
   End
   Begin Menu Edit 
      Caption         =   "Edit"
      Begin Menu Copy 
         Caption         =   "Copy"
      End
      Begin Menu Paste 
         Caption         =   "Paste"
      End
   End
End

Sub clearall_Click ()
Dim i As Integer

 Eigenvectors.enabled = False

 For i = 1 To dimension
   grid1.row = i
   For j = 1 To dimension
     grid1.col = j
     grid1.text = ""
   Next
 Next

 grid1.row = 0
 grid2.row = 1
 For i = 1 To dimension
   grid1.col = i
   grid2.col = i
   grid2.text = ""
   grid1.text = "Col " + Str$(i)
 Next

 grid1.row = 1
 grid1.col = 1
 grid1.selstartrow = 1
 grid1.selstartcol = 1
 grid1.selendrow = 1
 grid1.selendcol = 1
 text1.text = grid1.text


End Sub

Sub Copy_Click ()

  If TypeOf Screen.ActiveControl Is Grid Then
    Clipboard.SetText (Screen.ActiveControl.clip)
  End If
  
End Sub

Sub eigenvectors_Click ()
Dim i As Integer

 If startflag = True Then
   grid1.row = 0
   For i = 1 To dimension
     grid1.col = i
     grid1.text = "Eigenvector " + Str$(i)
   Next
 
   For i = 1 To dimension
     grid1.row = i
     For j = 1 To dimension
       grid1.col = j
       grid1.text = Str$(a(i, j))
     Next
   Next
   startflag = False
 End If

 grid1.row = 1
 grid1.col = 1
 grid1.selstartrow = 1
 grid1.selstartcol = 1
 grid1.selendrow = 1
 grid1.selendcol = 1
 text1.text = grid1.text


End Sub

Sub Form_Load ()

grid1.rows = InitialCells
grid1.cols = InitialCells
grid2.rows = 2
grid2.cols = InitialCells
grid1.row = 0
grid2.row = 0
grid1.col = 0
grid2.col = 0
grid1.colwidth = CellWidth
grid2.colwidth = CellWidth
dimension = InitialCells - 1

For i% = 1 To dimension
  grid1.row = 0
  grid2.row = 0
  grid1.col = i%
  grid2.col = i%
  grid1.colwidth = CellWidth
  grid2.colwidth = CellWidth
  grid1.text = "Col " + Str$(i%)
  grid2.text = "Eigenvalue " + Str$(i%)
  grid1.col = 0
  grid1.row = i%
  grid1.text = "Row " + Str$(i%)
Next i%

 grid1.row = 1
 grid1.col = 1
 grid1.selstartrow = 1
 grid1.selstartcol = 1
 grid1.selendrow = 1
 grid1.selendcol = 1
 text1.text = grid1.text


End Sub

Sub Grid1_KeyPress (KeyAscii As Integer)

 If grid1.row <> 0 And grid1.col <> 0 Then
   If (KeyAscii >= Low_Digit And KeyAscii <= Hi_Digit) Or Chr$(KeyAscii) = "." Then
     text1.SetFocus
     text1.text = ""
     SendKeys Chr$(KeyAscii)
   End If
 End If

End Sub

Sub Grid1_SelChange ()

 If grid1.row <> 0 And grid1.col <> 0 Then
   text1.text = grid1.text
 End If

End Sub

Sub grid1keyup ()
StringSize = Len(grid1.text)

If StringSize > 1 Then
  Last$ = Mid$(grid1.text, StringSize, StringSize)
Else
  Last$ = ""
End If



row% = grid1.row
col% = grid1.col

If row% <> 0 And col% <> 0 Then

  If KeyCode = Key_Return Then
    If col% >= row% Then
      If col% <= grid1.cols - 2 Then
        grid1.col = col% + 1
        grid1.selstartcol = grid1.col
        grid1.selstartrow = grid1.row
      Else
        If row% <= grid1.rows - 2 Then
          grid1.row = row% + 1
          grid1.col = grid1.row
          grid1.selstartcol = grid1.col
          grid1.selstartrow = grid1.row
        Else
          grid1.row = 2
          grid1.col = 1
          grid1.selstartcol = grid1.col
          grid1.selstartrow = grid1.row
        End If
      End If
    Else
      If row% <= grid1.rows - 2 Then
        grid1.row = row% + 1
        grid1.selstartcol = grid1.col
        grid1.selstartrow = grid1.row
      Else
        If col% <= grid1.cols - 3 Then
          grid1.col = col% + 1
          grid1.row = grid1.col + 1
          grid1.selstartcol = grid1.col
          grid1.selstartrow = grid1.row
        Else
          grid1.row = 1
          grid1.col = 1
          grid1.selstartcol = grid1.col
          grid1.selstartrow = grid1.row
        End If
      End If
    End If
  
  Else

  If KeyCode = Key_period And Last$ <> Chr$(Key_period) Then
    grid1.text = grid1.text + Chr$(KeyCode)
  End If

  If (KeyCode >= Low_Digit And KeyCode <= Hi_Digit) Then
    grid1.text = grid1.text + Chr$(KeyCode)
  Else
    If KeyCode = Key_Back And StringSize > 0 Then
      If StringSize = 1 Then
        grid1.text = ""
      Else
        grid1.text = Mid$(grid1.text, 1, StringSize - 1)
      End If
    End If
  End If

  hold$ = grid1.text
  grid1.row = col%
  grid1.col = row%
  grid1.text = hold$
  grid1.row = row%
  grid1.col = col%
  End If
End If

End Sub

Sub hold_click ()

row% = grid1.row
col% = grid1.col

If row% <> 0 And col% <> 0 Then

  If KeyAscii = Key_Return Then
    If col% >= row% Then
      If col% <= grid1.cols - 2 Then
        grid1.col = col% + 1
      Else
        If row% <= grid1.rows - 2 Then
          grid1.row = row% + 1
          grid1.col = row%
        Else
          grid1.row = 1
          grid1.col = 1
        End If
      End If
    Else
      If row% <= grid1.rows - 2 Then
        grid1.row = row% + 1
      Else
        If col% <= grid1.cols - 2 Then
          grid1.col = col% + 1
          grid1.row = col%
        Else
          grid1.row = 1
          grid1.col = 1
        End If
      End If
    End If
  
  Else


  End If
End If

End Sub

Sub hold2_click ()
StringSize = Len(grid1.text)
row% = grid1.row
col% = grid1.col

If row% <> 0 And col% <> 0 Then

  If KeyCode = Key_Return Then
    If col% >= row% Then
      If col% <= grid1.cols - 2 Then
        grid1.col = col% + 1
      Else
        If row% <= grid1.rows - 2 Then
          grid1.row = row% + 1
          grid1.col = row%
        Else
          grid1.row = 1
          grid1.col = 1
        End If
      End If
    Else
      If row% <= grid1.rows - 2 Then
        grid1.row = row% + 1
      Else
        If col% <= grid1.cols - 2 Then
          grid1.col = col% + 1
          grid1.row = col%
        Else
          grid1.row = 1
          grid1.col = 1
        End If
      End If
    End If
  
  Else


  If KeyCode >= Low_Digit And KeyCode <= Hi_Digit Then
    grid1.text = grid1.text + Chr$(KeyCode)
  Else
    If KeyCode = Key_Back And StringSize > 0 Then
      If StringSize = 1 Then
        grid1.text = ""
      Else
        grid1.text = Mid$(grid1.text, 1, StringSize - 1)
      End If
    End If
  End If

  hold$ = grid1.text
  grid1.row = col%
  grid1.col = row%
  grid1.text = hold$
  grid1.row = row%
  grid1.col = col%
  End If
End If

End Sub

Sub Initialize_Click ()

Eigenvectors.enabled = False

For i% = 1 To dimension
  grid1.row = i%
  For k% = 1 To dimension
    grid1.col = k%
    temp! = CSng(i%) + CSng(k%)
    grid1.text = Str$(temp!)
  Next k%
Next i%
    
 grid1.row = 1
 grid1.col = 1
 grid1.selstartrow = 1
 grid1.selstartcol = 1
 grid1.selendrow = 1
 grid1.selendcol = 1
 text1.text = grid1.text

End Sub

Sub move_click ()

End Sub

Sub Paste_Click ()

 If TypeOf Screen.ActiveControl Is Grid Then

   Screen.ActiveControl.clip = Clipboard.GetText()
   For i% = 1 To Screen.ActiveControl.rows - 1
     Screen.ActiveControl.row = i%
     For k% = 1 To Screen.ActiveControl.cols - 1
       Screen.ActiveControl.col = k%
       temp = Val(Screen.ActiveControl.text)
       Screen.ActiveControl.text = Str$(temp)
     Next k%
   Next i%

   grid1.row = 1
   grid1.col = 1
   grid1.selstartrow = 1
   grid1.selstartcol = 1
   grid1.selendrow = 1
   grid1.selendcol = 1
   text1.text = grid1.text
   
 End If


End Sub

Sub restore_original_Click ()

' Label3.caption = "For Symmetric Matrices Only"

  clearall_Click

   For i% = 1 To dimension
     grid1.row = i%
     For j% = 1 To dimension
       grid1.col = j%
       grid1.text = Str$(z(i%, j%))
     Next
   Next

 grid1.row = 1
 grid1.col = 1
 grid1.selstartrow = 1
 grid1.selstartcol = 1
 grid1.selendrow = 1
 grid1.selendcol = 1
 text1.text = grid1.text


End Sub

Sub Start_compute_Click ()

 Static d(1 To Maxdim) As Single
 Static e(1 To Maxdim) As Single
 Dim iterflag As Long

 Dim i As Integer
 Dim j As Integer

 startflag = True


 For i = 1 To dimension
   grid1.row = i
   For j = 1 To dimension
     grid1.col = j
     a(i, j) = Val(grid1.text)
     z(i, j) = a(i, j)
   Next
 Next

 Call TRED2(a(1, 1), dimension, Maxdim, d(1), e(1))
 Call TQLI(d(1), e(1), dimension, Maxdim, a(1, 1), iterflag)

 If iterflag = -1 Then
   MsgBox "There were too many iterations, try again with a simpler problem."
 Else
   grid2.row = 1
   For i = 1 To dimension
     grid2.col = i
     grid2.text = Str$(d(i))
   Next
 End If

 grid1.row = 1
 grid1.col = 1
 grid1.selstartrow = 1
 grid1.selstartcol = 1
 grid1.selendrow = 1
 grid1.selendcol = 1
 text1.text = grid1.text


 Eigenvectors.enabled = True

End Sub

Sub Text1_Change ()

If grid1.row <> 0 And grid1.col <> 0 Then
 row% = grid1.row
 col% = grid1.col

 If text1.text = "" Then
   tempstring$ = ""
 Else
   temp = Val(text1.text)
   tempstring$ = Str$(temp)
 End If


 grid1.text = tempstring$

 grid1.row = col%
 grid1.col = row%

 grid1.text = tempstring$

 grid1.row = row%
 grid1.col = col%

End If

End Sub

Sub Text1_KeyDown (KeyCode As Integer, Shift As Integer)

' If KeyCode = Key_Return Then
'   grid1.SetFocus
' End If

End Sub

Sub Text2_Change ()

End Sub

Sub Text3_Change ()
 
End Sub

Sub Text4_Change ()
 
End Sub

Sub Text5_KeyPress (KeyAscii As Integer)
  
 If KeyAscii = Key_Return Then
   grid1.row = 1
   grid1.col = 1
   grid1.selstartrow = 1
   grid1.selstartcol = 1
   grid1.selendrow = 1
   grid1.selendcol = 1
   grid1.SetFocus
 End If

End Sub

Sub Text5_LostFocus ()

If Val(text5.text) <= Maxdim And Val(text5.text) >= 1 Then
  grid1.cols = Val(text5.text) + 1
  dimension = Val(text5.text)
  grid1.rows = grid1.cols
  grid2.cols = grid1.cols


For i% = 1 To grid1.cols - 1
    grid1.row = 0
    grid2.row = 0
    grid1.col = i%
    grid2.col = i%
    grid1.colwidth = CellWidth
    grid2.colwidth = CellWidth
    grid1.text = "Col " + Str$(i%)
    grid2.text = "Eigenvalue " + Str$(i%)
    grid1.col = 0
    grid1.row = i%
    grid1.text = "Row " + Str$(i%)
  Next i%
  Else
    If text5.text <> "" Or Val(text5.text) <> 0 Then
      MsgBox "Dimesion invalid or out of range (1-" + Str$(Maxdim) + ")"
      text5.text = ""
  End If
End If

End Sub

Sub Text6_Change ()

End Sub

Sub Text8_Change ()
  
End Sub

