VERSION 2.00
Begin Form frmShuffleSetup 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Shuffle Configuration"
   ClientHeight    =   3060
   ClientLeft      =   1800
   ClientTop       =   2175
   ClientWidth     =   4965
   Height          =   3465
   Left            =   1740
   LinkTopic       =   "Form1"
   ScaleHeight     =   3060
   ScaleWidth      =   4965
   Top             =   1830
   Width           =   5085
   Begin VScrollBar vscVertSpin 
      Height          =   375
      Left            =   1920
      Max             =   -1
      Min             =   1
      TabIndex        =   11
      Top             =   600
      Width           =   255
   End
   Begin VScrollBar vscHorzSpin 
      Height          =   375
      Left            =   1920
      Max             =   -1
      Min             =   1
      TabIndex        =   10
      Top             =   120
      Width           =   255
   End
   Begin HScrollBar hscNumWide 
      Height          =   255
      Left            =   2160
      Max             =   20
      Min             =   2
      TabIndex        =   8
      Top             =   2640
      Value           =   8
      Width           =   615
   End
   Begin VScrollBar vscNumHigh 
      Height          =   615
      Left            =   3600
      Max             =   2
      Min             =   20
      TabIndex        =   7
      Top             =   1440
      Value           =   5
      Width           =   255
   End
   Begin PictureBox picLines 
      AutoRedraw      =   -1  'True
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   12
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      ForeColor       =   &H00000000&
      Height          =   1455
      Left            =   1320
      ScaleHeight     =   5
      ScaleMode       =   0  'User
      ScaleWidth      =   8
      TabIndex        =   6
      Top             =   1080
      Width           =   2175
   End
   Begin TextBox txtVertSpeed 
      Height          =   375
      Left            =   1320
      MaxLength       =   2
      TabIndex        =   3
      Text            =   "1"
      Top             =   600
      Width           =   615
   End
   Begin TextBox txtHorzSpeed 
      Height          =   375
      Left            =   1320
      MaxLength       =   2
      TabIndex        =   2
      Text            =   "4"
      Top             =   120
      Width           =   615
   End
   Begin CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3600
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3600
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin Label lblTileSize 
      AutoSize        =   -1  'True
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Tile Size:"
      Height          =   195
      Left            =   120
      TabIndex        =   9
      Top             =   1080
      Width           =   810
   End
   Begin Label lblVertSpeed 
      AutoSize        =   -1  'True
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Vert. Speed:"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   1080
   End
   Begin Label lblHorzSpeed 
      AutoSize        =   -1  'True
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Horz. Speed:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   1125
   End
End
Sub cmdCancel_Click ()
    Unload Me
End Sub

Sub cmdOK_Click ()
    If Screen.Width Mod hscNumWide.Value <> 0 Then
        MsgBox "The screen cannot be evenly divided into" & Str$(hscNumWide.Value) & " columns.", 64, "Uneven Columns"
        Exit Sub
    End If

    If Screen.Height Mod vscNumHigh.Value <> 0 Then
        MsgBox "The screen cannot be evenly divided into" & Str$(vscNumHigh.Value) & " rows.", 64, "Uneven Rows"
        Exit Sub
    End If

    WriteINIValues
    Unload Me
End Sub

Sub DrawLines (NumX As Integer, NumY As Integer)
    Dim iX As Integer, iY As Integer, sMsg As String

    ' Clear the picturebox and set the scalemode to match
    ' the selected number of rows and columns
    ' picLines.ScaleMode = 0 is automatically picked when
    ' scalewidth or height are changed...
    picLines.Cls
    picLines.ScaleWidth = NumX
    picLines.ScaleHeight = NumY

    ' Draw the lines...
    For iX = 1 To NumX - 1
        picLines.Line (iX, 0)-(iX, NumY)
    Next iX

    For iY = 1 To NumY - 1
        picLines.Line (0, iY)-(NumX, iY)
    Next iY
            
    ' Make a little string like '8 X 4' and center it within
    ' the picturebox...
    sMsg = CStr(NumX) & " x " & CStr(NumY)
    'picLines.ScaleMode = 1
    picLines.CurrentX = (picLines.ScaleWidth - picLines.TextWidth(sMsg)) / 2
    picLines.CurrentY = (picLines.ScaleHeight - picLines.TextHeight(sMsg)) / 2

    ' Print the string in blue if it divides the screen up evenly
    ' or red if not...
    picLines.ForeColor = &HFF0000 ' Blue
    If Screen.Width Mod hscNumWide.Value <> 0 Or Screen.Height Mod vscNumHigh.Value <> 0 Then
        picLines.ForeColor = &HFF ' Red
    End If
    picLines.Print sMsg
    picLines.ForeColor = &H0 ' Black
End Sub

Sub Form_Load ()
    txtHorzSpeed.Text = CStr(HorzSpeed)
    txtVertSpeed.Text = CStr(VertSpeed)
    hscNumWide.Value = NumBlocksX
    vscNumHigh.Value = NumBlocksY
    ' Me.show
    Call DrawLines((hscNumWide.Value), (vscNumHigh.Value))
End Sub

Sub hscNumWide_Change ()
    Call DrawLines((hscNumWide.Value), (vscNumHigh.Value))
End Sub

Sub txtHorzSpeed_LostFocus ()
    vscHorzSpin_Change
End Sub

Sub txtVertSpeed_LostFocus ()
    vscVertSpin_Change
End Sub

Sub vscHorzSpin_Change ()
    Const HORZ_MIN% = 1
    Const HORZ_MAX% = 50
    Static bIgnore As Integer, iNum As Integer
    
    If Not bIgnore Then
        iNum = Val(txtHorzSpeed.Text)
        iNum = iNum + vscHorzSpin.Value
        If iNum < HORZ_MIN Then iNum = HORZ_MIN
        If iNum > HORZ_MAX Then iNum = HORZ_MAX
        txtHorzSpeed.Text = CStr(iNum)
        bIgnore = True
        vscHorzSpin.Value = 0
        bIgnore = False
    End If
End Sub

Sub vscNumHigh_Change ()
    Call DrawLines((hscNumWide.Value), (vscNumHigh.Value))
End Sub

Sub vscVertSpin_Change ()
    Const VERT_MIN% = 1
    Const VERT_MAX% = 50
    Static bIgnore As Integer, iNum As Integer
    
    If Not bIgnore Then
        iNum = Val(txtVertSpeed.Text)
        iNum = iNum + vscVertSpin.Value
        If iNum < VERT_MIN Then iNum = VERT_MIN
        If iNum > VERT_MAX Then iNum = VERT_MAX
        txtVertSpeed.Text = CStr(iNum)
        bIgnore = True
        vscVertSpin.Value = 0
        bIgnore = False
    End If
End Sub

Sub WriteINIValues ()
    Dim RetVal As Integer
    
    RetVal = WritePrivateProfileString("Settings", "HorzSpeed", (txtHorzSpeed.Text), INI_FILE_NAME)
    RetVal = WritePrivateProfileString("Settings", "VertSpeed", (txtVertSpeed.Text), INI_FILE_NAME)
    RetVal = WritePrivateProfileString("Settings", "TilesWide", (hscNumWide.Value), INI_FILE_NAME)
    RetVal = WritePrivateProfileString("Settings", "TilesHigh", (vscNumHigh.Value), INI_FILE_NAME)
End Sub

